/////////////////////////////////////////////////
// boolean.h
//
// Copyright 1994, Scott Wood, CCP
//
// Definition for boolean true/false class
//
/////////////////////////////////////////////////

#ifndef __BOOLEAN_H
  #define __BOOLEAN_H

  #ifndef __PTDEFS_H
    #include <ptdefs.h>
    #endif
  #ifndef __IOSTREAM_H
    #include <iostream.h>
    #endif
  #ifndef __CSTRING_H
    #include <cstring.h>
    #endif

  #if  (!defined(TRUE))
    #define trueConst1 TRUE = 1,
  #elif (TRUE != 1)
    #error Boolean constant TRUE defined incorrectly
  #else
    #define trueConst1
  #endif

  #if  (!defined(FALSE))
    #define falseConst1 FALSE = 0,
  #elif (FALSE != 0)
    #error Boolean constant FALSE defined incorrectly
  #else
    #define falseConst1
  #endif

  #if  (!defined(true))
    #define trueConst2 true = 1,
  #elif (true != 1)
    #error Boolean constant true defined incorrectly
  #else
    #define trueConst2
  #endif

  #if  (!defined(false))
    #define falseConst2 false = 0,
  #elif (false != 0)
    #error Boolean constant false defined incorrectly
  #else
    #define falseConst2
  #endif

  #if ( defined(truE) || defined(falsE) )  // gotta have these
    #error Constants for class boolean already defined
  #endif

  // defines possible values
  enum booleanConstant
    {
      falseConst1 falseConst2 falsE = 0,
      trueConst1 trueConst2 truE = 1
    };

  // class boolean
  class _PTCLASS boolean
    {
      public:

        boolean (void);
        boolean (const int in);

        // if (val) test
        operator int() const;

        // complement value
        boolean _FAR & operator++();

        // stream operators
        friend ostream _FAR & _PTFUNC operator << (ostream _FAR & str, boolean _FAR & b);
        friend istream _FAR & _PTFUNC operator >> (istream _FAR & str, boolean _FAR & b);

      private:

        int pVal;
        void SetVal (const int i);
    };

  inline boolean::boolean (void)
      : pVal (0)
    {
    };

  inline boolean::boolean (const int in)
    {
      SetVal (in);
    };

  inline boolean::operator int() const
    {
      return pVal;
    };

  inline boolean _FAR & boolean::operator++()
    {
      SetVal (!pVal);
      return *this;
    };

  inline void boolean::SetVal (const int i)
    {
      pVal = (i != 0);
    };

  _PTDEF (string);
  string _PTFUNC GetEnumString (boolean &);

#endif

