/////////////////////////////////////////////////
// ptdefs.h
//
// Copyright 1994, Scott Wood, CCP
//
// Run-Time Library common header file.
//  Definitions for Classes, Functions, and Data
//  for use in DLLs and EXEs.
// Use of this header file will allow building
//  of DLL modules and their use.
//
// Usage:
//   Class Definition
//   class _PTCLASS MyClass {...};
//
//   Function Declaration
//   int _PTFUNC MyFunc (..) {...};
//
//   Forward Reference Declaration
//   _PTDEF (MyFunc);
//
/////////////////////////////////////////////////
#ifndef __PTDEFS_H
  #define __PTDEFS_H

  #ifndef ___DEFS_H
    #include <_defs.h>
    #endif

  typedef unsigned int  cardinal;
  typedef unsigned long longCardinal;

  #if defined(_BLDPTDLL)
  #  define _PTCLASS __export
  #  define _PTDATA  __export
  #  define _PTFUNC  __export
  #elif defined(_PTDLL)
  #  define _PTCLASS __import
  #  if defined(__FLAT__)
  #    define _PTDATA __import
  #    define _PTFUNC __import
  #  else
  #    define _PTDATA
  #    define _PTFUNC
  #  endif
  #else
  #  define _PTCLASS
  #  define _PTDATA
  #  define _PTFUNC
  #endif

  #define _PTDEF(name) class _PTCLASS name;

#endif

