#ifndef __RPTSETUP_H
  #define __RPTSETUP_H

  #include <owl\owlpch.h>
  #include <owl\dialog.h>
  #include <owl\printdia.h>
  #include <owl\button.h>
  #include <owl\edit.h>

  #ifndef __PTDEFS_H
	 #include <ptdefs.h>
	 #endif
  #ifndef __BOOLEAN_H
	 #include <boolean.h>
	 #endif
  #ifndef __FILENAME_H
	 #include <filename.h>
	 #endif
  #ifndef __EDITINCH_H
	 #include <editinch.h>
	 #endif

  enum reportOutputEnum
	 {
		reportOutputPrinter,
		reportOutputFile,
      reportOutputScreen,
    };

  #define SETCLEAR(flag, set, clear)((flag) = ((flag)&~(clear))|(set))

  class _PTCLASS DlgReportSetup : public TDialog //TPrintDialog
	 {
		public:

		  class _PTCLASS ReportData // : public TPrintDialog::TData
			 {
				public:

				  ReportData (void);
				 ~ReportData (void);

              void                Lock();
              void                Unlock();
              void                ClearDevMode();
              const DEVMODE far*  GetDevMode() const {return DevMode;}
              void                SetDevMode(const DEVMODE far* devMode);
              void                ClearDevNames();
              const DEVNAMES far* GetDevNames() const {return DevNames;}
              const char far*     GetDriverName() const;
              const char far*     GetDeviceName() const;
              const char far*     GetOutputName() const;
              void                SetDevNames(const char far* driver,
                                              const char far* device,
                                              const char far* output);
              TPrintDC*           TransferDC();

              DWORD Flags;
              DWORD Error;
              int   FromPage;
              int   ToPage;
              int   MinPage;
              int   MaxPage;
              int   Copies;

				  TRect Margins;

				  reportOutputEnum ReportOutput;

				  FileName OutputFile;

            private:

              HGLOBAL hDevMode;
              HGLOBAL hDevNames;
              HDC     hDC;

              DEVMODE  far* DevMode;
              DEVNAMES far* DevNames;

              friend class DlgReportSetup;
          };

		  DlgReportSetup (TWindow* parent, ReportData _FAR &);
		 ~DlgReportSetup (void) {};

        BOOL GetDefaultPrinter ();

		protected:

        int  DoSetupData ();

		  void SetupWindow (void);
		  void CmOk (void);
		  void BtnSelect (void);
		  void BtnBrowse (void);
		  void BtnPrinter (void);
		  void BtnFile (void);
		  DECLARE_RESPONSE_TABLE (DlgReportSetup);

		private:

        PRINTDLG pd;

		  ReportData _FAR & pData;

		  TEdit   *pEditFile;
		  TButton *pBtnSelect;
		  TButton *pBtnBrowse;

		  PTEditInch *pEditLMargin;
		  PTEditInch *pEditTMargin;
		  PTEditInch *pEditRMargin;
		  PTEditInch *pEditBMargin;

        TEdit *pEditCopies;
        
		  reportOutputEnum pOutput;

		  void pShowOutput (void);

	 };

#endif

