/////////////////////////////////////////////////
// strfuncs.h
//
// Copyright 1994, Scott Wood, CCP
//
// char buf string functions
//
/////////////////////////////////////////////////

#ifndef __STRFUNCS_H
  #define __STRFUNCS_H

  #ifndef __PTDEFS_H
    #include <ptdefs.h>
    #endif
  #ifndef __BOOLEAN_H
    #include <boolean.h>
    #endif
  #ifndef __CSTRING_H
    #include <cstring.h>
    #endif

  // strcpy with padded blank fill to end
  char _FAR * _PTFUNC strfcpy (char _FAR *dst, const char _FAR *src, int maxlen);

  // strncpy with guaranteed zero end
  int _PTFUNC stccpy (char _FAR *dst, const char _FAR *src, int maxlen);

  // test for null buf
  boolean _PTFUNC isstrnil (const char _FAR *str);

  // trim blanks off of buf
  char _FAR * _PTFUNC strtrim (char _FAR *);

  // center buf within length
  char _FAR * _PTFUNC strcntr (char _FAR *, char _FAR *, int);

  // determine if string is a number
  boolean _PTFUNC isNumber (const string _FAR & str);
  boolean _PTFUNC isNumber (const char _FAR * str);

#endif

