/////////////////////////////////////////////////
// cntrwin.cpp
//
// Copyright 1994, Scott Wood, CCP
//
// Center Window
//
/////////////////////////////////////////////////
#include <cntrwin.h>
#include <stdio.h>

void _PTFUNC CenterWindow  (HWND hDlg)
  {
    int cxWin, cyWin;
    int xDlg, yDlg;
    int cxDlg, cyDlg;
    int cxScreen, cyScreen;

    cxScreen = GetSystemMetrics (SM_CXSCREEN);
    cyScreen = GetSystemMetrics (SM_CYSCREEN);

    RECT prct;
    HWND hWndParent = GetParent (hDlg);
    if (IsWindow (hWndParent))
      {
        GetWindowRect (hWndParent, &prct);
        cxWin = prct.right - prct.left;
        cyWin = prct.bottom - prct.top;
      }
    else
      {
        cxWin = 0;
        cyWin = 0;
      };

    RECT drct;
    GetWindowRect (hDlg, &drct);

    cxDlg = drct.right - drct.left;
    cyDlg = drct.bottom - drct.top;

    xDlg = (cxWin - cxDlg) / 2;
    xDlg += prct.left;
    yDlg = (cyWin - cyDlg) / 2;
    yDlg += prct.top;

    if ((xDlg < 0) || (yDlg < 0) || (xDlg+cxDlg > cxScreen) ||
        (yDlg+cyDlg > cyScreen))
      {
        xDlg = (cxScreen - cxDlg) / 2;
        yDlg = (cyScreen - cyDlg) / 2;
      };

    MoveWindow (hDlg, xDlg, yDlg, cxDlg, cyDlg, TRUE);
  };

