#include <stdio.h>
#include <editinch.h>
#include <rptlib.h>

DEFINE_RESPONSE_TABLE1 (PTEditInch, TEdit)
  EV_WM_KILLFOCUS,
END_RESPONSE_TABLE;

PTEditInch::PTEditInch (TWindow *parent, int resid, float value, int precision)
	 : TEdit (parent, resid)
	 , pValue (value)
	 , pPrecision (precision)
  {
  };

float PTEditInch::GetValue (void)
  {
	 char buf[20];

	 GetText (buf, sizeof(buf));
	 return atof (buf);
  };

void PTEditInch::SetupWindow (void)
  {
	 TEdit::SetupWindow ();

	 char buf[20];
	 sprintf (buf, "%.*g\"", pPrecision, pValue);
	 SetText (buf);
  };

void PTEditInch::EvKillFocus (HWND hWndGetFocus)
  {
	 TEdit::EvKillFocus (hWndGetFocus);

	 char buf[20];
	 GetText (buf, sizeof(buf));
	 sprintf (buf, "%.*g\"", pPrecision, atof (buf));
	 SetText (buf);
  };

