/////////////////////////////////////////////////
// filename.cpp
//
// Copyright 1994, Scott Wood, CCP
//
// FileName class
//
/////////////////////////////////////////////////

#include <dir.h>
#include <direct.h>
#include <dos.h>
#include <filename.h>

FileName::FileName (void)
    :pDrive()
    ,pDir()
    ,pName()
    ,pExt()
  {
  };

FileName::FileName (const char _FAR *sourceString)
    :pDrive()
    ,pDir()
    ,pName()
    ,pExt()
  {
    pBuild (sourceString);
  };

FileName::FileName (const string _FAR & src)
    :pDrive()
    ,pDir()
    ,pName()
    ,pExt()
  {
    pBuild (src.c_str ());
  };

void FileName::pBuild (const char _FAR *src)
  {
    if (src && *src)
      {
        char drive [MAXDRIVE];
        char dir   [MAXDIR];
        char name  [MAXFILE];
        char ext   [MAXEXT];

        fnsplit (src, drive, dir, name, ext);

        pDrive = drive;
        pDir   = dir;
        pName  = name;
        pExt   = ext;
      }
    else
      {
        pDrive = (char)0;
        pDir   = (char)0;
        pName  = (char)0;
        pExt   = (char)0;
      };
  };

unsigned FileName::Hash (void) const
  {
    return Path().hash ();
  };

int FileName::Compare (const FileName _FAR &str) const
  {
    int caseSense = string::set_case_sensitive (0);
    int eq = Path().compare (str.Path ());
    string::set_case_sensitive (caseSense);
    return eq;
  };

ostream _FAR & _PTFUNC operator << (ostream _FAR & str, FileName _FAR & fileName)
  {
    str << fileName.Path ();
    return str;
  };

