#include <stdio.h>
#include <rptabort.h>
#include <stext.h>
#include <rptlib.h>
#include <rptlib.rh>
#include <cntrwin.h>

DlgReportAbort::DlgReportAbort (TWindow *parent, const char far *title,
        const char far *device, const char far *port)
    : TDialog (parent, IDD_PRTSTAT, ResMod)
    , pAbort (false)
  {
    new StaticText (this, IDC_PRTSTAT_TEXT_DESC, title);

    char buf[80];
    sprintf (buf, "%s on %s", device, port);
    new StaticText (this, IDC_PRTSTAT_TEXT_PRINTER, buf);
  };

void DlgReportAbort::SetupWindow (void)
  {
    TDialog::SetupWindow ();

    CenterWindow (HWindow);
  };

LRESULT DlgReportAbort::EvCommand (UINT id, HWND hWndCtl, UINT notifyCode)
  {
    pAbort = true;
    return TDialog::EvCommand (id, hWndCtl, notifyCode);
  };

void DlgReportAbort::ShowTitle (const string _FAR & title)
  {
    SetDlgItemText (IDC_PRTSTAT_TEXT_DESC, title.c_str ());
  };

void DlgReportAbort::ShowActivity (const string _FAR & activity)
  {
    SetDlgItemText (IDC_PRTSTAT_TEXT_ACTIVITY, activity.c_str ());
  };

void DlgReportAbort::ShowPageNumber (int pageNo)
  {
    char buf[10];

    sprintf (buf, "%d", pageNo);
    SetDlgItemText (IDC_PRTSTAT_TEXT_PAGENO, buf);
  };

