/////////////////////////////////////////////////
// strfuncs.cpp
//
// Copyright 1994, Scott Wood, CCP
//
// String function library
//
/////////////////////////////////////////////////

#include <string.h>
#include <strfuncs.h>
#include <ctype.h>

// determine if given str is blank
boolean _PTFUNC isstrnil (const char _FAR *str)
  {
    if (!str)
      return true;

    for (int i=0; str[i]; i++)
      if (str[i] != ' ')
        return false;

    return true;
  };

// strncpy with zero end
int _PTFUNC stccpy (char _FAR *dst, const char _FAR *src, int maxlen)
  {
    if (maxlen < 1)
      return 0;

    strncpy (dst, src, maxlen);
    dst[maxlen-1] = '\0';
    return maxlen;
  };

// center data within buf
char _FAR * _PTFUNC strcntr (char _FAR *src, char _FAR *dst, int len)
  {
    char buf[256];

    int i=0;
    int j=0;

    if (src)
      {
        strcpy (buf, src);

        i = strlen(src);
        j = len / 2 - strlen(src) / 2;
      };

    for (i=0; i < j; i++)
      dst[i] = ' ';
    for (j=0; buf[j]; j++, i++)
      dst[i] = buf[j];
    for (; i < len; i++)
      dst[i] = ' ';
    dst[i] = '\0';

    return dst;
  };

// strcpy with padded fill
char _FAR * _PTFUNC strfcpy (char _FAR *dst, const char _FAR *src, int maxlen)
  {
    char *str;

    str = dst;

    int i = 0;

    if (src)
      for (i=0; i < maxlen && src[i]; i++)
        dst[i] = src[i];

    while (i < maxlen)
      dst[i++] = ' ';

    return str;
  };

// trim blanks off string
char _FAR * _PTFUNC strtrim (char _FAR *str)
  {
    for (int beg=0; str[beg] && str[beg] == ' '; beg++);
    for (int end=strlen(str)-1; end > beg && str[end] == ' '; end--);

    for (int i=0; beg <= end; i++, beg++)
      str[i] = str[beg];
    str[i] = '\0';

    return str;
  };

// determine if number
boolean _PTFUNC isNumber (const string _FAR &str)
  {
    return isNumber (str.c_str ());
  };

boolean _PTFUNC isNumber (const char _FAR *str)
  {
    if (!str || !*str)
      return false;

    for (int i=0; str[i]; i++)
      if (!isdigit (str[i]))
        return false;

    return true;
  };

