#include <stdio.h>
#include <report.h>

class AppWindow : public TWindow
  {
    public:

      AppWindow (TWindow* parent = 0)
          : TWindow (parent)
        {};
  };

class TestApp : public TApplication
  {
    public:

      TestApp (void)
          : TApplication ()
        {};

      void InitMainWindow ();
  };

void TestApp::InitMainWindow ()
  {
    EnableBWCC ();

    SetMainWindow (new TFrameWindow (0, "Test Application", new AppWindow));
    nCmdShow = SW_SHOWMAXIMIZED;

    void DoTest (void);
    DoTest ();
  };

int OwlMain (int , char* [])
  {
    return TestApp ().Run ();
  };

void PrintHeader (Report _FAR *rpt, void *)
  {
    rpt->SetFontWeight (FW_BOLD);
    rpt->PrintCenterJustify ("This is a New Page");
    rpt->printf ("\n");
    rpt->PrintCenterJustify ("Title Is Centered and Bold");
    rpt->SetFontWeight (FW_NORMAL);
    rpt->printf ("\n\n");
  };

void DoTest (void)
  {
    Report rpt;

    if (!rpt.Open (true, "Test Report"))
      {
        MessageBox (0, "Unable to Initialize Printer", "", 0);
        return;
      };

    rpt.BeginReport ("Test Report");

    rpt.SetCharPerLine (80);
    rpt.SetPageHeader (PrintHeader, 0);

    rpt.printf ("This is the First Line of the Body\n\n");

    rpt.PrintLeftJustify ("This Line is Left Justified");
    rpt.printf ("\n");

    rpt.PrintRightJustify ("This Line is Right Justified");
    rpt.printf ("\n");

    rpt.PrintCenterJustify ("This Line is Centered");
    rpt.printf ("\n");

    rpt.printf ("Now Print a solid line\n");
    rpt.PrintLine (50);
    rpt.PrintNewLine ();

    rpt.printf ("Print a line of characters\n");
    rpt.PrintChar ('Z', 30);
    rpt.printf ("\n");

    rpt.printf ("Now Draw a Rectangle at the current position.\n");
    rpt.printf ("Make it 3 Lines high by 40 characters.\n\n");

    TRect rct;
    rct.left = rpt.X ();
    rct.top  = rpt.Y ();
    rct.bottom = rct.top + rpt.LineHeight () * 3;
    rct.right  = rct.left + rpt.CharWidth () * 40;
    rpt.Rectangle (rct);

    rpt.SetX (rct.left + rpt.CharWidth () * 5);
    rpt.SetY (rct.top + rpt.LineHeight ());
    rpt.printf ("Text inside of Rect");

    rpt.SetY (rct.bottom);
    rpt.printf ("\n\n");

    rpt.printf ("Report is Done\n");
    rpt.printf ("Hope that this Sample Helps!\n");

    rpt.EndReport ();
    rpt.Close ();
  };

